#!/usr/bin/python
import sys
import vxi11
import time
import numpy as np

log_name = "dcl_2vdc_abc_k46x_hulk1_2vrng_nplc50_soak20.csv"
log_named = "dcl_2vdc_abc_k46x_hulk1_2vrng_nplc50_soak20_raw.csv"

fluke = vxi11.Instrument("192.168.1.10", "gpib0,1") # Fluke 5720A, GPIB Address = 1
fluke.timeout = 25
#fluke.clear()
#fluke.write("*IDN?")
#print "Source detected = %s" % fluke.read()

dmm = vxi11.Instrument("192.168.1.10", "gpib0,2") # Keysight 3458A, GPIB Address = 1
dmm.timeout = 25
dmm.write("RESET")
dmm.clear()
#dmm.write("ID?")
#print "DUT1 detected = %s" % dmm.read()

dmm2 = vxi11.Instrument("192.168.1.10", "gpib0,3") # Keysight 3458A, GPIB Address = 1
dmm2.timeout = 25
dmm2.write("RESET")
dmm2.clear()
#dmm2.write("ID?")
#print "DUT2 detected = %s" % dmm2.read()

dmm3 = vxi11.Instrument("192.168.1.12", "gpib0,15") # Fluke 8508A, GPIB Address = 1
dmm3.timeout = 25
dmm3.write("*RST")
dmm3.clear()
dmm3.write("*IDN?")
print "DUT3 detected = %s" % dmm3.read()

dmm4 = vxi11.Instrument("192.168.1.10", "gpib0,11") # Fluke 8508A, GPIB Address = 1
dmm4.timeout = 25
dmm4.write("RESET")
dmm4.clear()
#dmm4.write("ID?")
#print "DUT4 detected = %s" % dmm4.read()

dmm5 = vxi11.Instrument("192.168.1.12", "gpib0,4") # Fluke 8508A, GPIB Address = 1
dmm5.timeout = 30
dmm5.clear()
dmm5.write("*IDN?")
print "DUTF detected = %s" % dmm5.read()

dmmf = vxi11.Instrument("192.168.1.12", "gpib0,6") # Fluke 8508A, GPIB Address = 1
dmmf.timeout = 30
dmmf.clear()
dmmf.write("*IDN?")
print "DUTD detected = %s" % dmmf.read()

#dmmn = vxi11.Instrument("192.168.1.10", "gpib0,19") # Fluke 8508A, GPIB Address = 1
#dmmn.timeout = 30
#dmmn.clear()
#dmmn.write("*IDN?")
#print "DUTD detected = %s" % dmmn.read()

fluke.write("STBY")
fluke.write("RANGELCK OFF")
fluke.write("OUT 1 V, 0 Hz")
fluke.write("RANGELCK ON")
fluke.write("STBY")
fluke.write("OUT 0.0 V, 0 Hz")
fluke.write("EXTGUARD ON")
fluke.write("OPER")
fluke.write("RANGELCK ON")
time.sleep(2)
print "SRC configured"

dmm.write("BEEP")
dmm.write("END ALWAYS")
dmm.write("DCV 10")
dmm.write("NPLC 50")
dmm.write("NDIG 8")
dmm.write("TRIG AUTO")
dmm.write("MATH OFF")
print "DUT configured, starting ACAL"

dmm2.write("BEEP")
dmm2.write("END ALWAYS")
dmm2.write("DCV 10")
dmm2.write("NPLC 50")
dmm2.write("NDIG 8")
dmm2.write("TRIG AUTO")
dmm2.write("MATH OFF")
print "DUT2 configured, starting ACAL"

#dmm3.write("BEEP")
#dmm3.write("END ALWAYS")
#dmm3.write("DCV 0.1")
#dmm3.write("NPLC 50")
#dmm3.write("NDIG 8")
#dmm3.write("TRIG AUTO")
#dmm3.write("MATH OFF")
#print "DUT3 configured, starting ACAL"

dmm4.write("BEEP")
dmm4.write("END ALWAYS")
dmm4.write("DCV 10")
dmm4.write("NPLC 50")
dmm4.write("NDIG 8")
dmm4.write("TRIG AUTO")
dmm4.write("MATH OFF")
print "DUT4 configured, starting ACAL"
'''
dmmd.write("*RST")
dmmd.write("TRG_SRCE EXT")
dmmd.write("DCV 10,FILT_OFF,RESL8,FAST_OFF")
dmmd.write("GUARD REM") #Int for 8508
dmmd.write("AVG OFF")
dmmd.write("INPUT CH_A")
#dmm3.write("GATE FAST_OFF")
#dmm3.write("C LAST_RDG")
#dmm3.write("SUB_C OFF")
print "DUTD configured"

dmmf.write("*RST")
dmmf.write("TRG_SRCE EXT")
dmmf.write("DCV 10,FILT_OFF,RESL8,FAST_OFF")
#dmmf.write("GUARD REM") #Int for 8508
dmmf.write("AVG OFF")
dmmf.write("INPUT FRONT")
#dmm3.write("GATE FAST_OFF")
#dmm3.write("C LAST_RDG")
#dmm3.write("SUB_C OFF")
print "DUTF configured"
'''
dmm3.write("*RST")
dmm3.write(":INIT:CONT OFF")
dmm3.write(":SYST:PRES")
dmm3.write(":FORM:ELEM READ")
dmm3.write(":SYST:AZER:STAT ON")
dmm3.write(":ABOR")
#dmm3.write(":INP:PRE:STAT OFF")
dmm3.write(":SENS:FUNC 'VOLT:DC'")
dmm3.write(":SENS:VOLT:DC:RANG 1")
dmm3.write(":SENS:VOLT:DC:NPLC 50")
dmm3.write(":SENS:VOLT:DC:AVER:STAT OFF")
dmm3.write(":SENS:VOLT:DC:DIG 9")

dmm5.write("*RST")
dmm5.write(":INIT:CONT OFF")
dmm5.write(":SYST:PRES")
dmm5.write(":FORM:ELEM READ")
dmm5.write(":SYST:AZER:STAT ON")
dmm5.write(":ABOR")
dmm5.write(":INP:PRE:STAT OFF")
dmm5.write(":SENS:FUNC 'VOLT:DC'")
dmm5.write(":SENS:VOLT:DC:RANG 1")
dmm5.write(":SENS:VOLT:DC:NPLC 50")
dmm5.write(":SENS:VOLT:DC:AVER:STAT OFF")
dmm5.write(":SENS:VOLT:DC:DIG 9")

#dmmn.write("*RST")
#dmmn.write(":INIT:CONT OFF")
#dmmn.write(":SYST:PRES")
#dmmn.write(":FORM:ELEM READ")
#dmmn.write(":SYST:FAZ:STAT ON")
#dmmn.write(":ABOR")
#dmmn.write(":SENS:FUNC 'VOLT:DC'")
#dmmn.write(":SENS:CHAN 1")
#dmmn.write(":SENS:VOLT:CHAN1:RANG 0.1")
#dmmn.write(":SENS:VOLT:CHAN1:NPLC 5")
#dmmn.write(":SENS:VOLT:CHAN1:AVER:STAT OFF")
#dmmn.write(":SENS:VOLT:CHAN1:DIG 7")

dmmf.write("*RST")
dmmf.write(":INIT:CONT OFF")
dmmf.write(":SYST:PRES")
dmmf.write(":FORM:ELEM READ")
dmmf.write(":SYST:AZER:STAT ON")
dmmf.write(":ABOR")
dmmf.write(":INP:PRE:STAT OFF")
dmmf.write(":SENS:FUNC 'VOLT:DC'")
dmmf.write(":SENS:VOLT:DC:RANG 1")
dmmf.write(":SENS:VOLT:DC:NPLC 50")
dmmf.write(":SENS:VOLT:DC:AVER:STAT OFF")
dmmf.write(":SENS:VOLT:DC:DIG 9")

#print "DUT4 configured"
'''
#dmm.write("ACAL DCV")
#dmm2.write("ACAL DCV")
#time.sleep(160)
'''
#for vcnt in range (0,2):
#    dmmd.write("*TRG;GET;RDG?")
#    dmmd.read()
#    #dmm4.write("READ?") # Get reading
#    #dmm4.read()
'''
'''
dmm.write("TARM SGL")
dmm.read()
dmm2.write("TARM SGL")
dmm2.read()
#dmm3.write("TARM SGL")
#dmm3.read()
dmm4.write("TARM SGL")
dmm4.read()
dmm.write("MATH NULL")
dmm2.write("MATH NULL")
#dmm3.write("MATH NULL")
dmm4.write("MATH NULL")
#dmm3.write("SUB_C OFF") # Null math
dmm.write("TARM SGL") # Get reading
dmm.read()
dmm2.write("TARM SGL") # Get reading
dmm2.read()
#dmm3.write("TARM SGL") # Get reading
#dmm3.read()
dmm4.write("TARM SGL") # Get reading
dmm4.read()
#dmm3.write("*TRG;GET;RDG?") # Get reading
#dmm3.read()
#dmm4.write("READ?") # Get reading
#dmm4.read()
print "DUTs is nulled to MFC zero"

with open(log_name, 'a') as dile:
    dile.write ("date;source;3458a;3458b;k15;3458c;k4;k6;dut2182;sdev;sdev2;sdev3;sdev4;sdevx;sdevf;sdevn;temp;temp2\r\n")
dile.close()

vcnt = 0 # temporary counter
print "Log into %s started" % log_name

for i in range(-200,200,1):
    median = 0.0
    sdev = 0.0
    array = []
    median2 = 0.0
    sdev2 = 0.0
    array2 = []
    median3 = 0.0
    sdev3 = 0.0
    array3 = []
    median4 = 0.0
    sdev4 = 0.0
    array4 = []
    medianx = 0.0
    sdevx = 0.0
    arrayx = []
    medianf = 0.0
    sdevf = 0.0
    arrayf = []
    mediann = 0.0
    sdevn = 0.0
    arrayn = []
    set_value = (float(i) / 100)
    fluke.write("OUT %.7f" % set_value)
    fluke.write("OPER")
    time.sleep(20)
    dmm.write("TEMP?")
    temp = float(dmm.read())
    for ix in range (0,12): #take more samples
	dmm.write("TARM SGL")
	dmm2.write("TARM SGL")
	#dmm3.write("TARM SGL")
	dmm4.write("TARM SGL")
	dmm3.write("FETCH?") #*TRG;GET;RDG?")
	dmmf.write("FETCH?") #*TRG;GET;RDG?")
	dmm5.write("FETCH?") #*TRG;GET;RDG?")
	#dmmf.write("*TRG;GET;RDG?")
	val = float(dmm.read())   #3
	val2 = float(dmm2.read()) #2
	val3 = float(dmm3.read()) #15
	val4 = float(dmm4.read()) #11
	valx = float(dmm5.read()) #4
	valf = float(dmmf.read()) #6
	valn = 0#float(dmmn.read())
	#dmm4.write("READ?")
	array.extend([val])
	array2.extend([val2])
	array3.extend([val3])
	array4.extend([val4])
	arrayx.extend([valx])
	arrayf.extend([valf])
	arrayn.extend([valn])
        temp2 = 24#float(dmm2.read())
	if (ix >= 2):
	    with open(log_named, 'a') as dil:
	        dil.write (time.strftime("%m%d%Y-%H:%M:%S;") + ("%.4f;%.9f;%.9f;%.9f;%.9f;%.9f;%.9f;%.9f;%.6f;%.6g;%.6g;%.6g;%.6g;%.6g;%.6g;%.1f;%.1f\r\n" % (set_value, val, val2, val3, val4, valx, valf, valn, sdev, sdev2, sdev3, sdev4, sdevx, sdevf, sdevn, temp, temp2)))
	    dil.close()
	if abs(set_value) >= 0.0005:
	    print("\033[33;1mA %.8f, ppm %.4f \033[35;1mB %.8f, ppm %.4f \033[37;1mC %.8f, ppm %.4f \033[32;1mD %.8f, ppm %.4f\033[39;0m X%.8f, ppm %.4f | F %.4f\033[39;0m | nV %.4f ppm" % (val, ((val / set_value - 1) * 1e6), val2,((val2 /set_value - 1) * 1e6), val3,((val3 / set_value - 1) * 1e6),val4,((val4 / set_value - 1) * 1e6),valx,((valx / set_value - 1) * 1e6),((valf / set_value - 1) * 1e6),((valn / set_value - 1) * 1e6) ))
    	if (abs(val) >= 9.9e36) or (abs(val2) >= 9.9e36):
	    print ("Smoke escaped, check connections")
	    fluke.write("OUT 0 V")
	    fluke.write("STBY")
	    quit()
    sdev = np.std(array[3:])
    median = np.median(array[5:])
    sdev2 = np.std(array2[3:])
    median2 = np.median(array2[5:])
    sdev3 = np.std(array3[3:])
    median3 = np.median(array3[5:])
    sdev4 = np.std(array4[3:])
    median4 = np.median(array4[5:])
    sdevx = np.std(arrayx[3:])
    medianx = np.median(arrayx[5:])
    sdevf = np.std(arrayf[3:])
    medianf = np.median(arrayf[5:])
    sdevn = np.std(arrayn[3:])
    mediann = np.median(arrayn[5:])
    if abs(float(i) / 10) >= 0.0005:
	dev1 = ((median / set_value - 1) * 1e6)
	dev2 = ((median2 /set_value - 1) * 1e6)
	dev3 = ((median3 /set_value - 1) * 1e6)
	dev4 = ((median4 /set_value - 1) * 1e6)
	devx = ((medianx /set_value - 1) * 1e6)
	devf = ((medianf /set_value - 1) * 1e6)
	devn = ((mediann /set_value - 1) * 1e6)
	print("\033[32;1mSRC %.4f \033[33;1mA %.9f, sdev5 = %.3f uV, med5 = %.8f\033[35;1mB %.9f, sdev5 = %.3f uV, med5 = %.8f \033[34;1m Delta %.4f ppm \033[37;1mC %.9f, sdev5 = %.3f uV, med5 = %.8f\033[32;1m D %.9f, sdev5 = %.3f uV, med5 = %.8f\033[39;0m" % (set_value, val, sdev*1e6, median, val2,sdev2*1e6, median2, (dev1 - dev2),  val3,sdev3*1e6, median3, val4,sdev4*1e6, median4 ))
        #dmm.write("DISP MSG,'%5.3f %2.1fV" % (dev1,set_value ))
        #dmm2.write("DISP MSG,'%5.3f %2.1fV" % (dev2,set_value ))
    #dmm.write("TEMP?")
    temp = 24#float(dmm.read())
    #dmm2.write("TEMP?")
    temp2 = 24#float(dmm2.read())
    with open(log_name, 'a') as dile:
        dile.write (time.strftime("%m%d%Y-%H:%M:%S;") + ("%.4f;%.9f;%.9f;%.9f;%.9f;%.9f;%.9f;%.9f;%.6f;%.6g;%.6g;%.6g;%.6g;%.6g;%.6g;%.1f;%.1f\r\n" % (set_value, median, median2, median3, median4, medianx, medianf, mediann, sdev, sdev2, sdev3, sdev4, sdevx, sdevf, sdevn, temp, temp2)))
    dile.close()

fluke.write("OUT 0 V")
fluke.write("STBY")
fluke.write("RANGELCK OFF")
dmm.write("RESET")
dmm2.write("RESET")
#dmm3.write("RESET")
dmm4.write("RESET")
dmm5.write("*RST")
dmmf.write("*RST")
dmm3.write("*RST")